// Gardien2
// OEN170321

const byte yBroPIR = 7;
const byte yBroLED = 13;
const byte yTempsKalib = 10;     // Max 30 secondes
const byte yBroSON = 8;                 // AJOUT

unsigned long gDebutChrono;         
unsigned long gPause = 100;    //  Max 5000
boolean bOKDetect = true;
boolean bRedemarrerKrono;  

/////////////////////////////
void setup(){
  Serial.begin(9600);
  pinMode(yBroPIR, INPUT);
  pinMode(yBroLED, OUTPUT);
  pinMode(yBroSON, OUTPUT);           // AJOUT
  digitalWrite(yBroPIR, LOW);
  
  Serial.println("** Projet GARDIEN. Calibrage du senseur.");
  Serial.print("** Que personne ne bouge. On patiente. ");
    for(int i = 0; i < yTempsKalib; i++) { 
      delay(1000);
      Serial.print(".");
      tone(yBroSON, 440, 200);        // AJOUT
    }
    Serial.println("C'est parti ! ");
    delay(50);
  }

////////////////////////////
void loop(){
  if(digitalRead(yBroPIR) == LOW) {
    if(bRedemarrerKrono) {
      gDebutChrono = millis(); 
      bRedemarrerKrono = false;
    }
    if(!bOKDetect && ( (millis() - gDebutChrono) > gPause) ) {
      bOKDetect = true;                        
      delay(50);
      bavarder(1);
    }
  }

  if(digitalRead(yBroPIR) == HIGH) {
    if(bOKDetect) {  
      bavarder(0);
      Serial.println("Alarme ! Alarme ! Alarme ! ");
      alarmer();                          // AJOUT 
      delay(50);
      bOKDetect = false;            
    }         
    bRedemarrerKrono = true;
  }
}

void bavarder(byte bType) {
  if (bType == 0) {
    Serial.println("---");
    Serial.print("Quelque chose bouge. Instant : ");
    Serial.print(millis()/1000);
    Serial.println(" secondes"); 
  }
  if (bType == 1) {
      Serial.print("Le calme est revenu. Instant : ");
      Serial.print((millis() - gPause)/1000);
      Serial.println(" secondes");
  }
}

void alarmer() {
  const int  iBasse  = 440;
  const int  iHaute = 2000;
  for (int i = iBasse; i < iHaute; i++) {
    tone(yBroSON, i);
    delay(1);
  }
  for (int i = iHaute; i > iBasse; i--) {
    tone(yBroSON, i);
    delay(1);
  }
  noTone(yBroSON);
}

