// VolKool1
// OEN170327

#include <Wire.h>
#include "Adafruit_TCS34725.h"

/* Exemple de la librairie Adafruit TCS34725*/
/* SCL sur broche A5, SDA sur broche A4, VDD sur 3.3V et GND sur GND */
   
Adafruit_TCS34725 oVolKool = Adafruit_TCS34725(TCS34725_INTEGRATIONTIME_700MS, TCS34725_GAIN_1X);

void setup(void) {
  Serial.begin(9600);
  if (oVolKool.begin()) { Serial.println( F("Capteur actif !") ); } 
  else { 
    Serial.println( F("TCS34725 absent. Voir les connexions!") ); 
    while (1); }
}

void loop(void) {
  uint16_t iR, iV, iB, iC, iTempera, lux;
  
  oVolKool.getRawData(&iR, &iV, &iB, &iC);
  iTempera = oVolKool.calculateColorTemperature(iR, iV, iB);
  lux = oVolKool.calculateLux(iR, iV, iB);
  
  Serial.print("Temperature de couleur: "); Serial.print(iTempera, DEC); 
  Serial.print(" K - ");
  Serial.print("Lux: "); Serial.print(lux, DEC); 
  Serial.println(" - ");
  Serial.print("Rouge: "); Serial.print(iR, DEC); Serial.print(" ");
  Serial.print("Vert:  "); Serial.print(iV, DEC); Serial.print(" ");
  Serial.print("Bleu:  "); Serial.print(iB, DEC); Serial.print(" ");
  Serial.print("C: "); Serial.print(iC, DEC); Serial.print(" ");
  Serial.println();
  Serial.println(" ");
}

