// KristaProverbe
// OEN170331

#include <LiquidCrystal.h>
#define LIG1 0
#define LIG2 1

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

#define MAXSUJ 11
char tcSujet[MAXSUJ][17] = {
  "Ne fais pas     ", 
  "N'oublie pas    ", 
  "Ne regarde pas  ", 
  "Ne pense pas    ", 
  "Ne raconte pas  ", 
  "Raconte leur    ", 
  "Ignore donc     ",
  "Ne nie pas      ",
  "Ne doute pas de ",
  "Ne dis pas      ",
  "Crois vraiment  " };

#define MAXOBJ 10
char tcObjet[MAXOBJ][17] = {
  "ce que je fais. ", 
  "ce que je vois. ", 
  "ce que j'aime.  ", 
  "ce que je dis.  ", 
  "ce que je crois.", 
  "ce que je pense.",
  "ce que tu penses",
  "ce que tu fais. ",
  "ce qu'ils font. ",
  "n'importe quoi. " };

byte bHasaS, bHasaO = 0;
byte yPrecSuj, yPrecObj = 0;

void setup() {
  lcd.begin(16, 2);
  Serial.begin(9600);
  randomSeed(analogRead(1)); 
}

void loop() {
  bHasaS = tirerAuSort(yPrecSuj, MAXSUJ);
  yPrecSuj = bHasaS;
  bHasaO = tirerAuSort(yPrecObj, MAXOBJ);
  yPrecObj = bHasaO;

  derouler(bHasaS, bHasaO);
  Serial.print(" Sujet : ");
  Serial.print(bHasaS);
  Serial.print(" Objet : ");
  Serial.println(bHasaO);
  delay(3000);
  lcd.clear();
}

byte tirerAuSort(byte prec, byte plafond) {
  byte bNbr;
  bNbr = random(0, plafond);
  while (bNbr == prec) { 
    Serial.print(bNbr);
    bNbr = random(0, plafond);
  }
  return(bNbr);  
}

void derouler(byte yChoiS, byte yChoiO) {
  byte yTour = 0;
  lcd.setCursor(0, LIG1 );
  for (yTour = 0; yTour < 16; yTour++) {
    lcd.print(tcSujet[yChoiS][yTour]);
    delay(50);
  }
  delay(500);
  lcd.setCursor(0, LIG2 );
  for (yTour = 0; yTour < 16; yTour++) {
    lcd.print(tcObjet[yChoiO][yTour]);
    delay(100);
  }
  delay(200);
}

