// TokanteFuzo
// OEN170331

#include <LiquidCrystal.h>
#include <RTClib.h>

#define LIG1 0
#define LIG2 1

#define FUZO 7                            // AJOUT (7 pour Tokyo)
#define VILLE "BEIJING"                   // MAX 7 car.!
char Tokyo[] = {196, 179, 183, 174, 179}; // AJOUT

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
RTC_DS1307 rtc;

const byte RETROECL = 10;
char jourSemaine[7][5] = {"Dim.", "Lun.", "Mar.", "Mer.", 
                          "Jeu.", "Ven.", "Sam."};
byte yMois, yJour, yH, yM, yS;

void setup() {
  lcd.begin(16, 2);
  Serial.begin(9600);
  if (! rtc.begin()) {
  lcd.println("Module RTC introuvable!");
    while (1);
  }
}

void loop() {
  DateTime oDaH = rtc.now();

  lcd.setCursor(0, LIG1);
  afficherDate(oDaH);
  afficherJourSem(oDaH);
  lcd.setCursor(0, LIG2);
  afficherHeure(oDaH, FUZO);
  delay(1000);

  // Tester bouton pour changer de fuseau.
}

void afficherDate(DateTime DT) {
  lcd.print(DT.year(), DEC);
  lcd.print('/');
  yMois = DT.month();
  if (yMois <10) lcd.print('0');
  lcd.print(yMois, DEC);
  lcd.print('/');
  yJour = DT.day();
  if (yJour <10) lcd.print('0');
  lcd.print(yJour, DEC);
}

void afficherJourSem(DateTime DT) {
  lcd.print(" ");
  lcd.print(jourSemaine[DT.dayOfTheWeek()]);
}

void afficherHeure(DateTime DT, byte pays) {
  yH = DT.hour();
  yH += pays;                    // AJOUT
  // Tester si >23 => -24
  if (yH > 23) yH -=24;          // AJOUT
  if (yH <10)   lcd.print('0');
  lcd.print(yH, DEC);
  lcd.print(':');
  yM = DT.minute();
  if (yM <10)   lcd.print('0');
  lcd.print(yM, DEC);
  lcd.print(':');
  yS = DT.second();
  if (yS <10)   lcd.print('0');
  lcd.print(yS, DEC);

  if (FUZO) {                  // AJOUT
    lcd.print(" "); 
    if (FUZO == 7) lcd.print(Tokyo); else lcd.print(VILLE); 
  }
}

