// AfficheurBoutons
/*************************************************************************************
  Variante FR du travail de Mark Bramwell, July 2010
**************************************************************************************/

#include <LiquidCrystal.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);           // select the pins used on the LCD panel

// define some values used by the panel and buttons
int iBouton     = 0;
int iValAna  = 0;

#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

int read_LCD_buttons(){               // read the buttons
    iValAna = analogRead(0);       // read the value from the sensor 

    // my buttons when read are centered at these valies: 0, 144, 329, 504, 741
    // we add approx 50 to those values and check to see if we are close
    // We make this the 1st option for speed reasons since it will be the most likely result

    if (iValAna > 1000) return btnNONE; 
    if (iValAna < 50)   return btnRIGHT;  
    if (iValAna < 250)  return btnUP; 
    if (iValAna < 450)  return btnDOWN; 
    if (iValAna < 650)  return btnLEFT; 
    if (iValAna < 850)  return btnSELECT;  

    return btnNONE;                // when all others fail, return this.
}

void setup(){
   lcd.begin(16, 2);               // start the library
   lcd.setCursor(0,0);             // set the LCD cursor   position 
   lcd.print("Quel bouton ?");  // print a simple message on the LCD
}
 
void loop(){
   lcd.setCursor(9,1);             // move cursor to second line "1" and 9 spaces over
   lcd.print(millis()/1000);       // display seconds elapsed since power-up

   lcd.setCursor(0,1);             // move to the begining of the second line
   iBouton = read_LCD_buttons();   // read the buttons

   switch (iBouton){               // depending on which button was pushed, we perform an action
       case btnRIGHT:{             //  push button "RIGHT" and show the word on the screen
            lcd.print("DROITE ");
            delay(800);
            break;
       }
       case btnLEFT:{
            lcd.print("GAUCHE"); //  push button "LEFT" and show the word on the screen
            delay(800);
            break;
       }    
       case btnUP:{
            lcd.print("HAUT  ");  //  push button "UP" and show the word on the screen
            delay(800);
            break;
       }
       case btnDOWN:{
            lcd.print("BAS   ");  //  push button "DOWN" and show the word on the screen
            delay(800);
            break;
       }
       case btnSELECT:{
            lcd.print("SELECT");  //  push button "SELECT" and show the word on the screen
            delay(800);
            break;
       }
       case btnNONE:{
            lcd.print("rien  ");  //  No action  will show "None" on the screen
            break;
       }
   }
}

