//------------------------------------------------------------------------------
// Exemple dont l'inspiration vient de
// dan@marginallyclever.com 2014-11-02
// Copyright en fin de texte source.
//------------------------------------------------------------------------------

#include "MorseTable.h"

#define TBASE     (80)
#define LED      (8)
#define MAX_BUF  (64)
#define BAUD     (9600)

//                            0        10        20        30        40        50
//                            0123456789012345678901234567890123456789012345678901234
static const char *letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,?'!/()&:;=+-_\"$@";

//------------------------------------------------------------------------------
// global variables
//------------------------------------------------------------------------------

char buffer[MAX_BUF] = "EVA ENGLER EST LA PLUS JOLIE !";
int soFar;
char message[6] = "Salut";
byte yBroSON = 13;

//------------------------------------------------------------------------------
// methods
//------------------------------------------------------------------------------

// Gstion LED
void on(char lettre) {
  digitalWrite(LED,HIGH);
}
void off() {
  digitalWrite(LED,LOW);
}


// short mark, dot or "dit" (·) — "dot duration" is one time unit long
void dot(char let) {
  on(let);
  tone(yBroSON, 440, 50);
  Serial.print('.');
  delay(TBASE);
}


// longer mark, dash or "dah" (–) — three time units long
void dash(char let) {
  on(let);
  tone(yBroSON, 440, 150);
  Serial.print('-');
  delay(TBASE*3);
}


// short gap between any combination of dots and dashes — one time unit long
void nextElement() {
  off();
  delay(TBASE);
}


// short gap (between letters) — three time units long
void nextLetter() {
  off();
  Serial.println("  ***");
  delay(TBASE*3);
}


// medium gap (between words) — seven time units long
void nextWord() {
  off();
  Serial.println("  *******");
  delay(TBASE*7);
}


void ready() {
  soFar=0;
  Serial.println("> ");
}


void setup() {
  // set up LED
  pinMode(LED,OUTPUT);
  off();
  
  // set up to talk with the PC.
  Serial.begin(BAUD);
  Serial.println("** Start **");
  ready();
}


void loop() {
  // listen for serial commands
  Serial.println("** ECRIRE EN MAJUSCULES ! **");
  Serial.println("** ET ACTIVER EN BAS \"Les deux, NL et CR\" **");
  processMessage(buffer);
  delay(1000);

  while( Serial.available() > 0 ) {
    char c = Serial.read();
    if( c == '\n' && soFar > 0 ) {
      buffer[soFar]=0;
      processMessage(buffer);
      ready();
    } else if( soFar < MAX_BUF ) {
      buffer[ soFar ] = c;
      soFar++;
    }
  }
}

void processMessage(char *message) {
  int i, first;

  // Initiale d'un nouveau mot ?
  first = 2;
  // Traite le texte fourni
  for( i=0; i<strlen(message); ++i ) {
    // Charge une lettre du message
    char c = message[i];

    if( c == ' ' ) {
      Serial.print("  ");
      nextWord();
      first = 1;
      Serial.print("\n");  // Saut de ligne
      continue;
    }
    if( first != 1 ) {
      nextLetter();
    }
      
    Serial.print(c);
    Serial.print(' ');
    // Conversion en Morse.
    morsifyLetter(c);
    off();
    first = 0;
    Serial.print("\n");
  }
}


// Cherche dans j la sequence codes[j] pour la lettre c
void morsifyLetter(char c) {
  int j;
  
  for( j=0; j<strlen(letters); ++j ) {
    if( letters[j] == c ) {
      // letters[j] est la bonne.
      blinkCodeSequence(j);
      // DOnc, on sort de la fonction
      return;
    }
  }
  Serial.print("** Introuvable **");
}


// Emission sequence codes[j]
void blinkCodeSequence(int j) {
  int i;

  for( i=0; i < strlen(codes[j]); ++i ) {
    // Silence entre bips
    if( i > 0 ) nextElement();

    if( codes[j][i] == '0' ) dash(j);
    if( codes[j][i] == '1' ) dot(j);
  }
}


/**
* This file is part of ArduinoStarterKit.
*
* You should have received a copy of the GNU General Public License
* along with Arduino Timer Interrupt. If not, see <http://www.gnu.org/licenses/>.
*/

